
@temp = ( ENV['TMPDIR'] || ENV['TMP'] || ENV['TEMP'] ).gsub('\\','/')



def method1
  # any shell command or an array of shell commands
  cmd = "convert.exe input.jpg -resize 50% output.jpg"

  # launch the shell command and give some callback code or callback method
  run_shell_command(cmd){
    method2()
  }
end



def run_shell_command(cmd, &proc)
  cmd = [cmd] if cmd.class != Array

  # create a batch script with the commands
  fbat = File.join(@temp, "temporary.bat")
  File.open(fbat, "w"){|f|
    f.puts "@echo off"
    cmd.each{|c| f.puts(c) }
    f.puts %[echo "finished" > "#{@temp.gsub(/\//,'//').gsub(/\//,'\\')}\\finished.txt"]
  }

  # create a Visual Basic file to launch the batch script without black console window
  fvbs = File.join(@temp, "temporary.vbs")
  File.open(fvbs, "w"){|f|
    f.puts %[Set WshShell = CreateObject("WScript.Shell")]
    f.puts %[WshShell.Run """#{fbat}""", 0]
    f.puts %[WScript.Quit]
  }
  # launch the vbs script
  system("wscript #{fvbs}")

  # since the batch script runs asynchronously, we need to know when it is finished
  # the batch script creates a "finished.txt" file, and we continue only when it is created
  self.file_observer(File.join(@temp,"finished.txt")){
    File.delete(fbat)
    File.delete(fvbs)
    proc.call
  }
end



def self.file_observer(file, &proc)
  if !File.exists?(file)
    UI.start_timer(0.5){ self.file_observer(file, &proc) }
  else
    File.delete(file)
    proc.call
  end
end
